| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::CallContentInterfaceDTMFInterface Class Reference

`#include <TelepathyQt/CallContent>`

Inherits Tp::AbstractInterface.

## Public Slots

QDBusPendingReply | StartTone (uchar event, int timeout=-1)
QDBusPendingReply | StopTone (int timeout=-1)
QDBusPendingReply | MultipleTones (const QString &tones, int timeout=-1)

## Signals

void | TonesDeferred (const QString &tones)
void | SendingTones (const QString &tones)
void | StoppedTones (bool cancelled)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| CallContentInterfaceDTMFInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| CallContentInterfaceDTMFInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| CallContentInterfaceDTMFInterface (Tp::DBusProxy *proxy)
| CallContentInterfaceDTMFInterface (const Tp::Client::CallContentInterface &mainInterface)
| CallContentInterfaceDTMFInterface (const Tp::Client::CallContentInterface &mainInterface, QObject *parent)
Tp::PendingVariant * | requestPropertyCurrentlySendingTones () const
Tp::PendingVariant * | requestPropertyDeferredTones () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Call1.Content.Interface.DTMF".

## Constructor & Destructor Documentation

Tp::Client::CallContentInterfaceDTMFInterface::CallContentInterfaceDTMFInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallContentInterfaceDTMFInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallContentInterfaceDTMFInterface::CallContentInterfaceDTMFInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallContentInterfaceDTMFInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallContentInterfaceDTMFInterface::CallContentInterfaceDTMFInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a CallContentInterfaceDTMFInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::CallContentInterfaceDTMFInterface::CallContentInterfaceDTMFInterface | ( | const Tp::Client::CallContentInterface & | mainInterface | ) |

explicit

Creates a CallContentInterfaceDTMFInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

Tp::Client::CallContentInterfaceDTMFInterface::CallContentInterfaceDTMFInterface | ( | const Tp::Client::CallContentInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a CallContentInterfaceDTMFInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::CallContentInterfaceDTMFInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Call1.Content.Interface.DTMF", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::CallContentInterfaceDTMFInterface::requestPropertyCurrentlySendingTones | ( |  | ) | const

inline

Asynchronous getter for the remote object property `CurrentlySendingTones` of type `bool`.

Indicates whether there are DTMF tones currently being sent in the channel. If so, the client should wait for StoppedTones signal before trying to send more tones.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentInterfaceDTMFInterface::requestPropertyDeferredTones | ( |  | ) | const

inline

Asynchronous getter for the remote object property `DeferredTones` of type `QString`.

The tones waiting for the user to continue, if any.

When this property is set to a non-empty value, TonesDeferred() is emitted. When any tones are played (i.e. whenever SendingTones() is emitted), this property is reset to the empty string.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::CallContentInterfaceDTMFInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::CallContentInterfaceDTMFInterface::StartTone | ( | uchar | event,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `StartTone` on the remote object.

Start sending a DTMF tone to all eligible streams in the channel. Where possible, the tone will continue until StopTone is called. On certain protocols, it may only be possible to send events with a predetermined length. In this case, the implementation MAY emit a fixed-length tone, and the StopTone method call SHOULD return NotAvailable. The client may wish to control the exact duration and timing of the tones sent as a result of user's interaction with the dialpad, thus starting and stopping the tone sending explicitly. Tone overlaping or queueing is not supported, so this method can only be called if no DTMF tones are already being played.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  event

      A numeric event code from the DTMF_Event enum.

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallContentInterfaceDTMFInterface::StopTone | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `StopTone` on the remote object.

Stop sending any DTMF tones which have been started using the StartTone or MultipleTones methods. If there is no current tone, this method will do nothing. If MultipleTones was used, the client should not assume the sending has stopped immediately; instead, the client should wait for the StoppedTones signal. On some protocols it might be impossible to cancel queued tones immediately.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallContentInterfaceDTMFInterface::MultipleTones | ( | const QString & | tones,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `MultipleTones` on the remote object.

Send multiple DTMF events to all eligible streams in the channel. Each tone will be played for an implementation-defined number of milliseconds (typically 250ms), followed by a gap before the next tone is played (typically 100ms). The duration and gap are defined by the protocol or connection manager. In cases where the client knows in advance the tone sequence it wants to send, it's easier to use this method than manually start and stop each tone in the sequence. The tone and gap lengths may need to vary for interoperability, according to the protocol and other implementations' ability to recognise tones. At the time of writing, GStreamer uses a minimum of 250ms tones and 100ms gaps when playing in-band DTMF in the normal audio stream, or 70ms tones and 50ms gaps when encoding DTMF as audio/telephone-event. Tone overlaping or queueing is not supported, so this method can only be called if no DTMF tones are already being played.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  tones

  A string representation of one or more DTMF events. Implementations of this method MUST support all of the following characters in this string:
  - the digits 0-9, letters A-D and a-d, and symbols '*' and '#' correspond to the members of DTMF_Event
  - any of 'p', 'P', 'x', 'X' or ',' (comma) results in an implementation-defined pause, typically for 3 seconds
  - 'w' or 'W' waits for the user to continue, by stopping interpretation of the string, and if there is more to be played, emitting the TonesDeferred() signal with the rest of the string as its argument: see that signal for details

  timeout | The timeout in milliseconds.

void Tp::Client::CallContentInterfaceDTMFInterface::TonesDeferred | ( | const QString & | tones | ) |

signal

Represents the signal `TonesDeferred` on the remote object.

Emitted when 'w' or 'W', indicating "wait for the user to continue", is encountered while playing a DTMF string queued by MultipleTones() . Any queued DTMF events after the 'w', which have not yet been played, are placed in the DeferredTones property and copied into this signal's argument.

When the channel handler is ready to continue, it MAY pass the value of DeferredTones to MultipleTones() , to resume sending. Alternatively, it MAY ignore the deferred tones, or even play different tones instead. Any deferred tones are discarded the next time a tone is played.

This signal SHOULD NOT be emitted if there is nothing left to play, i.e. if the 'w' was the last character in the DTMF string.

Parameters

  tones

      The new non-empty value of DeferredTones.

void Tp::Client::CallContentInterfaceDTMFInterface::SendingTones | ( | const QString & | tones | ) |

signal

Represents the signal `SendingTones` on the remote object.

DTMF tone(s)are being sent to all eligible streams in the channel. The signal is provided to indicating the fact that the streams are currently being used to send one or more DTMF tones, so any other media input is not getting through to the audio stream. It also serves as a cue for the StopTone() method.

Parameters

  tones

      DTMF string (one or more events) that is to be played.

void Tp::Client::CallContentInterfaceDTMFInterface::StoppedTones | ( | bool | cancelled | ) |

signal

Represents the signal `StoppedTones` on the remote object.

DTMF tones have finished playing on streams in this channel.

Parameters

  cancelled

      True if the DTMF tones were actively cancelled via StopTone.

void Tp::Client::CallContentInterfaceDTMFInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.